# Prerequires

## Development work environment

Currently, Visual Studio Code is used as IDE but any should work.

Dependencies are listed in the file `dependencies.csv`

## Tests work environment

**You'll need the `models/` directory**, put at the root of the project ( with `bin/`, `src/`, ...).
This directory is stored in beegfs at `work/eugene/models/`.
You can get it from symbiose at `"/mnt/beegfs/work/eugene/models/`.

**You must have python3 installed** (any version should work, tested on 3.10.12).

For the integration tests to work, **you must have set your ssh-key connection (without password) with symbiose (147.100.179.77)**
so that the script is able to get the data.

Then you can run the command: `make test-integration`.
It should take 15-20 minutes depending of your computer.

To run all the tests: `make tests`

# Developper command

## Build command

Usual commands:

* `make` or ` make default` or `make dynamic`: build the binary, with sensors plugins compatibility (aka. dynamic version binary)
* `make static`: build the binary without the plugins compatibility (aka. static version binary)
* `make debug`: build a dynamic version binary with debug mode on => more messages and compiled with `-g -Og`

To ensure to fully rebuild, including sensors, you can use `make javel` before any previous command

If you want a really fast build, you can use make's multijobs: `make javel && make -j N <nothing|default|dynamic|static>` with N whatever number of jobs (aka. core) you want to use

# Technical documentation

The technical documentation should be build automaticly.
You can build it alone with `make doc`.

You can access the technical documentation at ` doc/html/index.html`.
