
#ifndef GENEFEATURESET_H
#define GENEFEATURESET_H
//#define _VACPP_TR1

/** \cond */ // Do not include standard depedencies in doxygen graph
#include <string>
#include <iostream>
#include <map>
#include <vector>
/** \endcond */

#include "GeneFeature.hpp"
#include "SoTerms.hpp"

/**
 * class GeneFeatureSet
 */

    
class GeneFeatureSet
{
  
  private:
    std::vector <GeneFeature *> vRefFeatures_;
    std::map <std::string, int> mPosFeatures_;
    int lastIndex_;
    std::map <std::string, std::vector<GeneFeature *> > parentToChildren_;
  public:
    static SoTerms * soTerms_ ;
    // Constructors/Destructors
    GeneFeatureSet ( );
    GeneFeatureSet ( char* featuresFilename);
    virtual ~GeneFeatureSet ( );
    bool existsGeneFeature ( std::string geneFeatureId ) const ;
    void printFeature() const;
    std::vector< GeneFeature *>::const_iterator getIterator () const;
    std::map< std::string, std::vector<GeneFeature *> >::const_iterator getIteratorParentToChildren () const;
    const std::vector< GeneFeature *>& getChildren(std::string id) const;
    int getNbFeature () const;
    int getNbParentFeature () const;
    const GeneFeature * getGeneFeature (std::string id ) const;
};

#endif // GENEFEATURESET_H
