
#ifndef SOTERMS_H
#define SOTERMS_H

/** \cond */ // Do not include standard depedencies in doxygen graph
#include <string>
#include <map>
#include <iostream>
/** \endcond */

/**
 * class SoTerms
    
    example of enregistrement
    [Term]
    id: SO:0000000
    name: Sequence_Ontology
    subset: SOFA
    is_a: SO:... ! 

 */


class SoTerms
{
  private:
    std::map <std::string,std::string>  idToName_;
    std::map <std::string,std::string>  nameToId_;
    std::map <std::string, std::string> isA_;

  public:
  
    // Constructors/Destructors
    SoTerms();
    ~SoTerms ( );
    void loadSoFile();
    void loadFile( char * filename );
    bool existsId   (std::string name) const;
    bool existsName (std::string name) const;
    int size() const;
    void Print () const;
    std::string getIdFromName(std::string name) const;
    std::string getIsAFromId (std::string id) const;
    bool   isANcRNA     (std::string id) const;

};
#endif // SOTERMS_H
