// ------------------------------------------------------------------
// Copyright (C) 2004 INRA <eugene@ossau.toulouse.inra.fr>
//
// This program is open source; you can redistribute it and/or modify
// it under the terms of the Artistic License (see LICENSE file).
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//
// You should have received a copy of Artistic License along with
// this program; if not, please see http://www.opensource.org
//
// $Id$
// ------------------------------------------------------------------

#ifndef  SENSOR_ANNOTASTRUCT_H_INCLUDED
#define  SENSOR_ANNOTASTRUCT_H_INCLUDED

#include <algorithm>
#include "../../MSensor.hpp"

#include "../../GeneFeatureSet.hpp"

/*************************************************************
 **                      SensorAnnotaStruct
 *************************************************************/
class SensorAnnotaStruct : public Sensor
{
 private:
  std::vector <Signals*>  vSig;
  std::vector <Contents*> vCon;
  size_t   PosSigGiveInfo, PosConGiveInfo;
  int   iSig, iCon;
  char  *fileExt;
  std::string  transFeatName;
  char  startPAR[20], stopPAR[20],   accPAR[20];
  char  donPAR[20],   tStartPAR[20], tStopPAR[20];
  char tStartNpcPAR[20], tStopNpcPAR[20];
  float exonPAR,      intronPAR,     cdsPAR, npcRnaPAR, igPAR;
  int  exonInline,      intronInline,     cdsInline, npcRnaInline, igInline;
  int  startInline,      stopInline,     accInline;
  int  donInline,      tStartInline,     tStopInline;
  int  tStartNpcInline, tStopNpcInline;
  void ReadAnnotaStruct(char[FILENAME_MAX+1], int seqlen);
  void FillOntologyTerm(GeneFeatureSet & geneFeatureSet);
  void ReadAnnotaStructGff3(GeneFeatureSet & geneFeatureSet, int len);
  void PushInCon(int d,   int e,     float *sc,
		 char st, char p[2], int f);
  char * GetScoreC (int type , float scF, bool inlineScore);
 public:
  SensorAnnotaStruct          (int n, DNASeq *X);
  static Sensor* constructor ( int n, DNASeq *X, MasterSensor* ms );
  virtual ~SensorAnnotaStruct () override;
  virtual void Init           (DNASeq *) override;
  virtual void GiveInfo       (DNASeq *X, size_t, DATA *) override;
};

#endif
