// ------------------------------------------------------------------
// Copyright (C) 2004 INRA <eugene@ossau.toulouse.inra.fr>
//
// This program is open source; you can redistribute it and/or modify
// it under the terms of the Artistic License (see LICENSE file).
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//
// You should have received a copy of Artistic License along with
// this program; if not, please see http://www.opensource.org
//
// $Id$
// ------------------------------------------------------------------
// File:     Sensor.BlastX.h
// Contents: Sensor BlastX
// ------------------------------------------------------------------


#ifndef  SENSOR_BLASTX_H_INCLUDED
#define  SENSOR_BLASTX_H_INCLUDED

#include "../../MSensor.hpp"
#include "../../Hits.hpp"
#include "../../State.hpp"

/*************************************************************
 **                     SensorBlastX                        **
 *************************************************************/
class SensorBlastX : public Sensor
{
 private:
  std::vector<float> ProtMatch;
  std::vector<float> ProtMatchLevel;
  std::vector<int>ProtMatchPhase;
  std::vector<size_t> vPos;
  std::vector<int> vPMPhase;
  std::vector<float> vPMatch;
  std::vector<size_t>::iterator iter;
  char  *levels;
  char  *intronlevels;
  int    index;
  float keyBXLevel[10];
  int    minIn;
  int    blastxM;
  int    ppNumber;
  int    initid;
  int    stepid;
  int    N;
  int    sloppy;

  void LoadContentScore (DNASeq *);
  char ph06             (char);

  // For postprocess 2
  Hits **HitTable;
  int  NumProt;
  void ProtSupport ( const Prediction* const, FILE *, size_t debut, size_t fin,
		    Hits **HitTable,  int Size,  int NumG) const;

  int  LenSup      (Hits **HitTable, State* state, unsigned char* Sup,
                    std::vector<int> vSupProtI, int& additionalsup,
                    int index, size_t beg, size_t end) const;

  void Print (char name[FILENAME_MAX+1]);

 public:
  SensorBlastX            (int n, DNASeq *X);
  virtual ~SensorBlastX   () override;
  static Sensor* constructor( int, DNASeq*, MasterSensor* );
  virtual void Init       (DNASeq *) override;
  virtual void GiveInfo   (DNASeq *, size_t, DATA *) override;
  virtual void PostAnalyse( const Prediction * const, FILE *) override;
};
#endif
