// ------------------------------------------------------------------
// Copyright (C) 2004 INRA <eugene@ossau.toulouse.inra.fr>
//
// This program is open source; you can redistribute it and/or modify
// it under the terms of the Artistic License (see LICENSE file).
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//
// You should have received a copy of Artistic License along with
// this program; if not, please see http://www.opensource.org
//
// $Id$
// ------------------------------------------------------------------
// File:     Sensor.EuStop.h
// Contents: Sensor EuStop
// ------------------------------------------------------------------

#ifndef  SENSOR_EUSTOP_H_INCLUDED
#define  SENSOR_EUSTOP_H_INCLUDED

#include "../../MSensor.hpp"

/*************************************************************
 **                     SensorEuStop                        **
 *************************************************************/
class SensorEuStop : public Sensor
{
 private:
  double   stopP;

 public:
  SensorEuStop            (int n, DNASeq *X);
  virtual ~SensorEuStop   () override;
  static Sensor* constructor ( int, DNASeq*, MasterSensor* );
  virtual void Init       (DNASeq *) override;
  virtual void GiveInfo   (DNASeq *X, size_t, DATA *) override;
  virtual void Plot       (DNASeq *X) override;
};

#endif
