// ------------------------------------------------------------------
// Copyright (C) 2004 INRA <eugene@ossau.toulouse.inra.fr>
//
// This program is open source; you can redistribute it and/or modify
// it under the terms of the Artistic License (see LICENSE file).
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//
// You should have received a copy of Artistic License along with
// this program; if not, please see http://www.opensource.org
//
// $Id$
// ------------------------------------------------------------------
// File:     Sensor.MarkovConst.h
// Contents: Sensor MarkovConst
// ------------------------------------------------------------------

#ifndef  SENSOR_MARKOVCONST_INCLUDED
#define  SENSOR_MARKOVCONST_INCLUDED

#include "../../MSensor.hpp"

/*************************************************************
 **                     SensorMarkovConst                    **
 *************************************************************/
class SensorMarkovConst : public Sensor
{
 private:
  double transCodant, transIntron, transIntronU, transInter, transUTR5, transUTR3, transUIR, transRNA;
  int affectedStrand;
  double minGC,maxGC;

 public:
  SensorMarkovConst  (int n, DNASeq *X);
  virtual ~SensorMarkovConst   () override;
  static Sensor* constructor( int, DNASeq*, MasterSensor* );
  virtual void Init       (DNASeq *) override;
  virtual void GiveInfo   (DNASeq *, size_t, DATA *) override;
};

#endif
