// ------------------------------------------------------------------
// Copyright (C) 2004 INRA <eugene@ossau.toulouse.inra.fr>
//
// This program is open source; you can redistribute it and/or modify
// it under the terms of the Artistic License (see LICENSE file).
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// You should have received a copy of Artistic License along with
// this program; if not, please see http://www.opensource.org
//
// $Id$
// ------------------------------------------------------------------
// File:     Sensor.NStretch.h
// Contents: Sensor NStretch
// ------------------------------------------------------------------

#ifndef  SENSOR_NSTRETCH_INCLUDED
#define  SENSOR_NSTRETCH_INCLUDED

#include "../../MSensor.hpp"

/*************************************************************
 **                     SensorNStretch                    **
 *************************************************************/
class SensorNStretch : public Sensor
{
private:
    unsigned char *insideNStretch;
    double stretchPenalty;
    int maxLengthWithoutPenalty; // Penalize region of N with a length upper than maxLengthWithoutPenalty

public:
    SensorNStretch  (int n, DNASeq *X);
    virtual ~SensorNStretch   () override;
    static Sensor* constructor( int n, DNASeq* X, MasterSensor* ){ return new SensorNStretch(n, X ); }
    virtual void Init       (DNASeq *) override;
    virtual void GiveInfo   (DNASeq *, size_t, DATA *) override;
};

#endif
