#! /usr/bin/env bash

# This script is intended for lipme dev only, it requires be in a git-cloned repository
# It will updates the makefile variables based on the current git status

if [ ! $(git rev-parse --is-inside-work-tree) == "true" ]; then
	echo "Not in a git repository, not update Makefile.variables"
	exit 1
fi

git fetch --tags

version=$(git describe --tags)
sed -i "s/EUGENE_VERSION=.*/EUGENE_VERSION=${version}/g" Makefile.variables